#!/usr/bin/python

import os
import sys
import glob

username            = os.getlogin()
sourceDir           = os.getcwd()


# fill the following out
#------------------------------------------------------------------------------------------------
myHome              = os.path.join("/", os.path.join("nfs", os.path.join("home", "sushil")))
assignmentName      = "Assignment2"
destinationPathRoot = os.path.join("/", os.path.join ("nfs", os.path.join("home", os.path.join("sushil", os.path.join("cs1", "assignments")))))
destinationDir      = os.path.join(destinationPathRoot, os.path.join(assignmentName, username))
inputFiles          = glob.glob(os.path.join(destinationPathRoot, os.path.join(assignmentName, "*.in")))
correctOutputs      = os.path.join(destinationPathRoot, os.path.join(assignmentName, "outputs"))
gradingHome         = os.path.join(myHome, os.path.join("classes", os.path.join("135", "grading")))
#------------------------------------------------------------------------------------------------
print sourceDir, destinationDir
print "Input files: ", inputFiles


#---------------------------------------------------
# start compilation
#---------------------------------------------------
def sushilid(sushilsuid):
    def result():
        print os.getuid(), os.getgid()
        os.setuid(sushilsuid)
        studentid = os.getuid()
        os.setreuid(sushilid, sushilid)
        print os.getuid(), os.getgid()
    return result


print "--------------------Starting compilation-------------------------"

import subprocess
import shlex
import stat

try:
    os.chdir(destinationDir);
    perms = os.stat(destinationDir).st_mode
    print "mode: ", perms
    os.chmod(destinationDir, 0777)
    if True:
        commandLine = "make student"
        #commandLine = "id"
        args = shlex.split(commandLine)
        print "Compiling with: "
        print  commandLine
        print ""
        returnValue = subprocess.call(args)
#        returnValue = subprocess.Popen(args, preexec_fn=sushilid(2015408658));
        os.chmod(destinationDir, 0700)

    else:
        print "--------------No Source files, exiting...---------------------"
        sys.exit(1)

except OSError:
    print "-------------------------Compiling Error----------------------------"
    raise

#-------------------------------------------------
# check if run exists
#-------------------------------------------------
try:
    if not os.path.exists(os.path.join(destinationDir, "spong")):
        print "----------------Compiler errors, exiting...----------------------"
        sys.exit(1)
except OSError:
    print "---------------Could not check for executable---------------------"
    raise

print "-------------------Compiling Successful------------------------"

print "-----------------------Ready to Run----------------------------"

#------------------------------------------
#--now execute with inputfiles
#-----------------------------------------

outfilename = os.path.join(destinationDir, "out")
#print "Output: ", outfilename
try:

    if os.path.exists(outfilename):
        os.unlink (outfilename)

    outfd = open(outfilename, "a")
    #print "Input files: ", inputFiles
    if inputFiles:
        for f in inputFiles:
            commandline = "./run < " + f + " >> " + outfilename
            infd = open(f, "r")

            head, tail = os.path.split(f)
            outfd.write("**Test input file: "+ tail + "\n");
            outfd.flush()

            args = shlex.split(commandline)
            returnValue = subprocess.call(args, stderr=subprocess.STDOUT, stdout=outfd, stdin=infd)
            outfd.flush()
            outfd.write("**End of test input\n")
            outfd.flush()
            infd.close()
    else:
        os.chmod(destinationDir, 0777)
        commandline = "./spong"
        args = shlex.split(commandline)
        print "Args: " , args
        returnValue = subprocess.Popen(args, stderr=subprocess.STDOUT)
        import time
        time.sleep(5)
        returnValue.terminate()
        commandline = "/usr/bin/reset"
        args = shlex.split(commandline)
        returnValue = subprocess.call(args)#, stderr=subprocess.STDOUT)
#     returnValue = subprocess.Popen(args)
        os.chmod(destinationDir, 0700)
    outfd.close()
       
except OSError:
    print "-------------------------Execution Error----------------------------"
    raise

#---------------------------------------------
#--What's your output
#---------------------------------------------

#----------printFile(outfilename)------------

outfilename = os.path.join(destinationDir, "Grading.data")

try:
    if os.path.exists(outfilename):
        outfd = open(outfilename)
        lines = outfd.readlines()
        if len(lines) == 0 :
            print  "100%"
        else:
            #print "**Your program's output:"
            for line in lines:
                print line.strip()
            print "**End of your error output"
except OSError:
    print "-------Could not print program output--------"
    raise


#---------------------------------------------
#--What's the difference
#---------------------------------------------

sys.exit(0)
